/*
 *	tm16.c - 16rbg^C}
 *
 *	* Sun Feb 03 07:25:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <piece.h>
#include <s1c33cpu.h>
#include "c33208.h"

#define plc_IO ((volatile struct c_IOtag*)0x40000)	/* c33208.hp */
char vbuff[DISP_X * DISP_Y];				/* zVRAM */

#define CLOCK	24000000	/* x[XNbN */
int tone = 400;			/* ̍[Hz] */
int duty =  50;			/* f[eB[%] */

/****************************************************************************
 *	pceAppInit
 ****************************************************************************/

void
pceAppInit()
{
	/* ʏ̏B */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

DISABLE;
	/* 16bit^C}1~܂B
	 * 16bit^C}쒆ɁAvXP[̐ݒύXĂ͂܂B
	 */
	pT16_CTL1 = 0;

	/* P23/TM1TM1NbNo͂ɐ؂ւB */
	bP2_CFP2_CFP23 = 1;

	/* vXP[I(/1)ANB */
	pCLKCTL_T16_1 = 1 << 3 | 0;

	/* 16bit^C}1RyAf[^ݒB */
	pT16_CR1A = (CLOCK * duty / tone / 100) - 1;
	pT16_CR1B = (CLOCK        / tone      ) - 1;

	/* 16bit^C}1N܂B
	 * bit0: N/~        -> 1 (N)
	 * bit1: vZbg       -> 1 (ZbgB0݂͖̏)
	 * bit2: NbNo     -> 1 (o͂)
	 * bit3: ̓NbN     -> 0 (NbN)
	 * bit4: o͔]         -> 0 (]Ȃ1)
	 * bit5: RyAobt@ -> 1 (gp)
	 * bit6: t@C[h   -> 0 (ʏ탂[h2)
	 * 1 P/ECẼTEhhCóAo͔]ɐݒ肵Ă܂A
	 *     ł͂܂o͔]ȂŎĂ݂邱Ƃɂ܂B
	 * 2 P/ECẼTEhhCóAt@C[hgpĂ܂A
	 *     ł͂܂{IȒʏ탂[hŎĂ݂邱Ƃɂ܂B
	 */
	pT16_CTL1 = 0x27;

	/* P31:I[fBIp[(0:ON/1:OFF)ݒB */
	bP3_P3D_P31D = 0; /*ON*/
ENABLE;
}

/****************************************************************************
 *	pceAppExit
 ****************************************************************************/

void
pceAppExit()
{
DISABLE;
	/* 16bit^C}1~܂B
	 * ۂɂ́ÃAvP[V͒ʏ̕@ł͏IA
	 * ZbgxN^փWv̂ŁAւ͗܂B
	 */
	pT16_CTL1 = 0;
ENABLE;
}

/****************************************************************************
 *	pceAppProc
 ****************************************************************************/

void
pceAppProc(int count)
{
	int pad;

	pad = pcePadGet();
	if(pad & TRG_A) {
		/* A{^ꂽI܂B
		 * 16bit^C}1̐ݒ́AP/ECEZbgɈxsA
		 * AvP[VIĂĐݒ肳܂B
		 * ʏ̕@łIƁǍ̓삪sɂȂ邽߁A
		 * ZbgxN^փWvāAŐݒ肵Ă炢܂B
		 */
		asm("
			xld.w	%r4, 0xC00000
			jp	%r4
		");
	}
	/* ㉺ŉ̍ς܂B */
	if(pad & TRG_UP) {
		tone = tone * 105 / 100;
		if(tone > 6400) tone = 6400;
	} else if(pad & TRG_DN) {
		tone = tone * 100 / 105;
		if(tone < 400) tone = 400;
	}
	/* EŃf[eBς܂B */
	if(pad & TRG_LF) {
		duty -= 2;
		if(duty < 0) duty = 0;
	} else if(pad & TRG_RI) {
		duty += 2;
		if(duty > 100) duty = 100;
	}

	/* 16bit^C}1RyAf[^ݒB */
	pT16_CR1A = (CLOCK / tone * duty / 100) - 1;
	pT16_CR1B = (CLOCK / tone             ) - 1;

	/* ݂̐ݒl\܂B */
	memset(vbuff, 0, sizeof vbuff);
	pceFontSetPos(0, 0);
	pceFontPrintf("`{^ŏII\n");
	pceFontPrintf("߱A:%4d(%04x)\n", duty, pT16_CR1A);
	pceFontPrintf("߱B:%4d(%04x)\n", tone, pT16_CR1B);
	pceLCDTrans();
}
